from OpenGL.GL import *

class Material(object):
	def __init__(self):
		self.__ambient = (0.6, 0.6, 0.6, 1.0)
		self.__specular = (0.3, 0.3, 0.3, 1.0)
		self.__shininess = 100

		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, self.__ambient)
		glMaterialfv(GL_FRONT, GL_SPECULAR, self.__specular)
		glMaterialf(GL_FRONT, GL_SHININESS, self.__shininess)

	def __get_ambient(self):
		return self.__ambient

	def __set_ambient(self, ambient):
		if len(ambient) == 4:
			self.__ambient = ambient
		elif len(ambient) == 3:
			self.__ambient == ambient + (1.0, )
		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, self.__ambient)

	ambient = property(__get_ambient, __set_ambient)

	def __get_specular(self):
		return self.__specular
			        
	def __set_specular(self, specular):
		if len(specular) == 4:
			self.__specular = specular
		elif len(specular) == 3:
			self.__specular == specular + (1.0, )
		glMaterialfv(GL_FRONT, GL_SPECULAR, self.__specular)

	specular = property(__get_specular, __set_specular)

	def __get_shininess(self):
		return self.__shininess
			        
	def __set_shininess(self, shininess):
		self.__shininess = shiness
		glMaterialfv(GL_FRONT, GL_SHININESS, self.__shininess)

	shininess = property(__get_shininess, __set_shininess)
