from OpenGL.GL import *
import pygame.image

class Texture:
	def __init__(self, file):
		self.__id = glGenTextures(1)

		surf = pygame.image.load(file)
		if surf.get_bitsize() == 24:
			iformat = GL_RGB8
			format = GL_RGB
			data = pygame.image.tostring(surf, "RGB", 1)
		elif surf.get_bitsize() == 32:
			iformat = GL_RGBA8
			format = GL_RGBA
			data = pygame.image.tostring(surf, "RGB", 1)

		glBindTexture(GL_TEXTURE_2D, self.__id)
		glTexImage2D( GL_TEXTURE_2D, 0, iformat, surf.get_width(), surf.get_height(), 0, format, GL_UNSIGNED_BYTE, data)
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST)
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST)


	def __del__(self):
		glDeleteTextures(self.__id)


	def __get_id(self):
		return self.__id

	id = property(__get_id)


	def bind(self):
		glBindTexture(GL_TEXTURE_2D, self.__id)
